/*
 * Copyright (c) 2013-2019 Huawei Technologies Co., Ltd. All rights reserved.
 * Copyright (c) 2020-2021 Huawei Device Co., Ltd. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this list of
 * conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list
 * of conditions and the following disclaimer in the documentation and/or other materials
 * provided with the distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its contributors may be used
 * to endorse or promote products derived from this software without specific prior written
 * permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
// 版权声明，说明该代码由华为技术有限公司和华为设备有限公司所有，并规定了代码的使用和分发条件。

#include "lt_net_netdb.h"
// 引入头文件，可能包含了网络数据库相关的函数声明和宏定义。

static int GetHostByNameTest(void)
{
    // 定义一个模拟的hosts文件内容
    char host_file[] = "127.0.0.1 localhost\n";
    // 定义hosts文件的路径列表
    char *pathList[] = {"/etc/hosts"};
    // 定义模拟的hosts文件流列表
    char *streamList[] = {host_file};
    // 定义模拟的hosts文件流长度列表
    int streamLen[] = {sizeof(host_file)};
    // 定义文件数量
    int flag = PrepareFileEnv(pathList, streamList, streamLen, 1);
    // 如果准备文件环境失败，则恢复原始文件环境并返回错误码
    if (flag != 0) {
        RecoveryFileEnv(pathList, 1);
        return -1;
    }

    // 使用gethostbyname函数根据主机名获取hostent结构体指针
    struct hostent *addr = gethostbyname("localhost");
    // 断言addr不为空，即gethostbyname成功
    ICUNIT_ASSERT_NOT_EQUAL(addr, NULL, -1);
    // 断言返回的主机名与输入的主机名相同
    ICUNIT_ASSERT_EQUAL(strcmp(addr->h_name, "localhost"), 0, -1);
    // 断言返回的地址类型为AF_INET
    ICUNIT_ASSERT_EQUAL(addr->h_addrtype, AF_INET, addr->h_addrtype);
    // 断言返回的地址长度不为0
    ICUNIT_ASSERT_NOT_EQUAL(addr->h_length, 0, addr->h_length);

    // 测试gethostbyname函数，传入IP地址字符串作为主机名
    addr = gethostbyname("127.0.0.1");
    ICUNIT_ASSERT_NOT_EQUAL(addr, NULL, -1);
    ICUNIT_ASSERT_EQUAL(strcmp(addr->h_name, "127.0.0.1"), 0, -1);
    ICUNIT_ASSERT_EQUAL(addr->h_addrtype, AF_INET, addr->h_addrtype);
    ICUNIT_ASSERT_NOT_EQUAL(addr->h_length, 0, addr->h_length);

    // 测试一个不存在的主机名
    addr = gethostbyname("lo");
    // 断言addr为空，即gethostbyname失败
    ICUNIT_ASSERT_EQUAL(addr, NULL, -1);

    // 恢复原始文件环境
    RecoveryFileEnv(pathList, 1);
    return ICUNIT_SUCCESS;
}

// 定义测试用例
void NetNetDbTest006(void)
{
    // 添加测试用例，指定测试函数、测试类型、测试级别等信息
    TEST_ADD_CASE(__FUNCTION__, GetHostByNameTest, TEST_POSIX, TEST_TCP, TEST_LEVEL0, TEST_FUNCTION);
}